#include <iostream>
#include <SDL/SDL.h>

//g++ -o myprogram sdlc.cpp -lSDL

using std::cerr;
using std::endl;

//The attributes of the display
const int SCREEN_WIDTH = 854;
const int SCREEN_HEIGHT = 480;
const int SCREEN_BPP = 32;

void apply_surface( int x, int y, SDL_Surface* source, SDL_Surface* destination )
{
    //Make a temporary rectangle to hold the offsets
    SDL_Rect offset;

    //Give the offsets to the rectangle
    offset.x = x;
    offset.y = y;

    //Blit the surface
    SDL_BlitSurface( source, NULL, destination, &offset );
}
bool keyPressed(SDLKey key)
{
    Uint8 keys[SDLK_LAST];
    Uint8* sdlKeys = SDL_GetKeyState(0);
    memcpy(keys, sdlKeys, sizeof(keys));
    return keys[SDLK_UP] == SDL_PRESSED;
}

int main(int argc, char* args[])
{
// Initialize the SDL
SDL_Surface *display = NULL;
display = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_SWSURFACE );
    if (SDL_Init(SDL_INIT_VIDEO) != 0)
 {
  cerr << "SDL_Init() Failed: " << SDL_GetError() << endl;
  exit(1);
 }
 // Get the current video hardware information
   const SDL_VideoInfo* myPointer = SDL_GetVideoInfo();
// Print out some information
// WARNING: myPointer is not NULL here
   std::cout << "Current video resolution is " << myPointer->current_w << "x" << myPointer->current_h << " pixels" << std::endl;
   
// Load the image
SDL_Surface *background = NULL;
//The optimized image that will be used
SDL_Surface* optimizedImage = NULL;
//background = SDL_LoadBMP("backgroundwoodtest.bmp");
background = SDL_LoadBMP("background.bmp");
//If something went wrong in loading the image
 if (background == NULL)
 {
     cerr << "SDL_LoadBMP() Failed: " << SDL_GetError() << endl;
     exit(1);
 }
// Load the image
SDL_Surface *upbutton = NULL;
upbutton = SDL_LoadBMP("upb.bmp");
//If something went wrong in loading the image
 if (upbutton == NULL)
 {
     cerr << "SDL_LoadBMP() Failed: " << SDL_GetError() << endl;
     exit(1);
 }
// Load the image
SDL_Surface *downbutton = NULL;
downbutton = SDL_LoadBMP("downb.bmp");
//If something went wrong in loading the image
 if (downbutton == NULL)
 {
     cerr << "SDL_LoadBMP() Failed: " << SDL_GetError() << endl;
     exit(1);
 }

// Load the image
SDL_Surface *rightbutton = NULL;
rightbutton = SDL_LoadBMP("rightb.bmp");
//If something went wrong in loading the image
 if (rightbutton == NULL)
 {
     cerr << "SDL_LoadBMP() Failed: " << SDL_GetError() << endl;
     exit(1);
 }
 
// Load the image
SDL_Surface *leftbutton = NULL;
leftbutton = SDL_LoadBMP("leftb.bmp");
//If something went wrong in loading the image
 if (leftbutton == NULL)
 {
     cerr << "SDL_LoadBMP() Failed: " << SDL_GetError() << endl;
     exit(1);
 }
    if (SDL_BlitSurface(background, NULL, display, NULL) != 0)
  {
 cerr << "SDL_BlitSurface() Failed: " << SDL_GetError() << endl;
  exit(1);
  }
  
  if (SDL_BlitSurface(upbutton, NULL, display, NULL) != 0)
  {
 cerr << "SDL_BlitSurface() Failed: " << SDL_GetError() << endl;
  exit(1);
  }
    if (SDL_BlitSurface(downbutton, NULL, display, NULL) != 0)
  {
 cerr << "SDL_BlitSurface() Failed: " << SDL_GetError() << endl;
  exit(1);
  }
    if (SDL_BlitSurface(leftbutton, NULL, display, NULL) != 0)
  {
 cerr << "SDL_BlitSurface() Failed: " << SDL_GetError() << endl;
  exit(1);
  }
    if (SDL_BlitSurface(rightbutton, NULL, display, NULL) != 0)
  {
 cerr << "SDL_BlitSurface() Failed: " << SDL_GetError() << endl;
  exit(1);
  }
  

//Apply the background to the screen
   apply_surface( 0, 0, background, display );
   apply_surface( 854, 0, background, display );
   apply_surface( 0, 480, background, display);
   apply_surface( 854, 480, background, display );

//Apply the message to the screen
  apply_surface( 160, 300, upbutton, display );
  apply_surface( 160, 400, downbutton, display );
  apply_surface( 75, 350, leftbutton, display );
  apply_surface( 240, 350, rightbutton, display );
//Update the display
  SDL_Flip(display);

 
 // Main loop
 SDL_Event event;
 // Movement variable;
 bool move_left = false;
 bool move_right = false;
 bool move_up = false;
 bool move_down = false;
 bool sdlc = true;
 int mouse_x, mouse_y;

 while(sdlc)
{
  // Check for messages
  if (SDL_PollEvent(&event)){
    
    if (event.type == SDL_QUIT)
{
    printf("Bye bye...\n");
    sdlc = false;
}
   // Check for keys
if (event.type == SDL_KEYDOWN)
{
   SDLKey key = event.key.keysym.sym;
   if (key == SDLK_ESCAPE){
      sdlc = false;
     printf("Bye bye Esc...\n");
}
   if (key == SDLK_q){
      sdlc = false;
     printf("Bye bye Esc...\n");
}
   if (key == SDLK_LEFT){
      move_left = true;}
   if (key == SDLK_RIGHT){
      move_right = true;}
   if (key == SDLK_UP){
      move_up = true;
      printf("up got pressed...\n");}
   if (key == SDLK_DOWN){
      move_down = true;}
}
if (event.type == SDL_KEYUP)
{
   SDLKey key = event.key.keysym.sym;
   if (key == SDLK_LEFT)
      move_left = false;
   if (key == SDLK_RIGHT)
      move_right = false;
   if (key == SDLK_UP)
      move_up = false;
   if (key == SDLK_DOWN)
      move_down = false;
}
//*********************************************here need to be reworked
// Mouse events	
if (event.type == SDL_MOUSEBUTTONDOWN) {
  
	SDL_GetMouseState(&mouse_x, &mouse_y);
	SDLKey key = event.key.keysym.sym;
		if ( (mouse_x >= 175) && (mouse_y >= 326) )
		    printf("Mouse Activite!\n");
		    bool keyPressed();
		    
		
			}
}
  

}
    // Tell the SDL to clean up and shut down
    SDL_Quit();
     return 0;    
}
